# Conduct Policy

## Our Pledge

In the interest of fostering an open and welcoming environment, we as
contributors and maintainers pledge to making participation in our project and
our community a harassment-free experience for everyone, regardless of age, body
size, disability, ethnicity, sex characteristics, gender identity and expression,
level of experience, education, socio-economic status, nationality, personal
appearance, race, religion, political party membership, or sexual identity and orientation.

## Our Standards

The abiding standard with all interactions shall be "Be Polite". It is a simple
rule by which to live, as it covers a very broad range of behavior. While some
might complain that it is a vague standard by which to police a community,
we believe the vagueness is a feature. Interpersonal interactions require thoughtfulness
and context. They are vague by their nature.

Examples of behavior that contributes to creating a positive environment
include:

* Using welcoming and inclusive language
* Being respectful of differing viewpoints and experiences
* Gracefully accepting constructive criticism
* Focusing on what is best for the community
* Showing empathy towards other community members

If you need examples of unacceptable behavior for participants, you're
missing the point of "Be Polite". Err on the side of caution. Treat conversations
here like conversations with a person you're just meeting for the first time at
a party. Or better yet, at a funeral.

## Our Responsibilities

Project maintainers are NOT responsible for clarifying the standards of acceptable
behavior. Contributors are expected to behave in a polite manner without having
politness explained to them. "Not understanding the standards" will not be an
acceptable excuse for impolitness. 

Project maintainers are expected to take swift, appropriate corrective action in
response to any instances of unacceptable behavior. In cases of heated arguments,
this will lead to warnings. In cases of personal attacks and harassments, this will
lead to immediate banning from the project.

Project maintainers have the right and responsibility to remove, edit, or
reject comments, commits, code, wiki edits, issues, and other contributions
that are not aligned to this Conduct Policy, or to ban temporarily or
permanently any contributor for other behaviors that they deem inappropriate,
threatening, offensive, or harmful.

## Scope

This Conduct Policy applies to project contributors across any sphere of life. 
If any contributor is found to be harrassing, abusing, or generally being impolite 
to any other contributor or user, they will be banned.

## Enforcement

Instances of abusive, harassing, or otherwise unacceptable behavior may be
reported by contacting the project team at sean.mcbeth+gh@gmail.com. All
complaints will be reviewed and investigated and will result in a response that
is deemed necessary and appropriate to the circumstances. The project team is
obligated to maintain confidentiality with regard to the reporter of an incident.
Further details of specific enforcement policies may be posted separately.

Project maintainers who do not follow or enforce the Conduct Policy in good
faith may face temporary or permanent repercussions as determined by other
members of the project's leadership.

## Attribution

This Conduct Policy is adapted from the [Contributor Covenant][homepage], version 1.4,
available at https://www.contributor-covenant.org/version/1/4/code-of-conduct.html

[homepage]: https://www.contributor-covenant.org

For answers to common questions about the Contributor Covenant, see
https://www.contributor-covenant.org/faq

For answers to questions about our changes to the Contributor Covenant for
the Conduct Policy, please email the project team at sean.mcbeth+gh@gmail.com.
